<?php

class CommfortSend
{
	private $url = '127.0.0.1:9752';
	private $NameApp = 'SiteApp';
	private $CommfortUser = 'UserHelloWorld';
	private $CommfortPass = '1q2w3e4r';
	private $CommfortChanel = 'main';
	private $id = 1;
	private $TypeMessage = 0;
	private $id_cont;
	private $user_type = 0;

	public function __construct()
	{
		if(file_exists('id/cont_init.dat'))
		{
			$IdCont = file_get_contents('id/cont_init.dat');
			if($this->TestingUserInChat($IdCont) != 9) $this->ConnectToCommfort();
		}
		else $this->ConnectToCommfort();
		$this->id_cont = file_get_contents('id/cont_init.dat');
		$this->ConnectUser();
		if(!$this->CommfortChanel != 'main') $this->ConnecToChanel();
	}

	private function ConnectToCommfort()
	{
		$json   = json_encode(array('jsonrpc' => '2.0', 'method' => 'conn_init', 'params' => array('app_name' => $this->NameApp),'id'=>$this->id));
		$JsonData = json_decode($this->CurlTo($json),true);
		file_put_contents('id/cont_init.dat',$JsonData[result][conn_id]);
	}

	private function CurlTo($json)
	{
		$ch     = curl_init();
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-type: application/json'));
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, 'json='.urlencode($json));
		curl_setopt($ch, CURLOPT_URL, trim($this->url));
		$result = curl_exec($ch);
		$err    = curl_error($ch);
		return $result;
	}

	private function ConnectUser()
	{
		$json   = json_encode(array('jsonrpc' => '2.0', 'method' => 'user_connect', 'params' => array('conn_id' => $this->id_cont,'nick'=>$this->CommfortUser,'pass'=>md5($this->CommfortPass)),'id'=>$this->id));
		json_decode($this->CurlTo($json),true);
	}

	private function TestingUserInChat($IdCont)
	{
		$json   = json_encode(array('jsonrpc' => '2.0', 'method' => 'get_auth_state', 'params' => array('conn_id' => $IdCont),'id'=>$this->id));
		$JsonData = json_decode($this->CurlTo($json),true);
		return $JsonData[result];
	}

	private function ConnecToChanel()
	{
		$json   = json_encode(array('jsonrpc' => '2.0', 'method' => 'channel_connect', 'params' => array('conn_id' => $this->id_cont,'channel' => $this->CommfortChanel,'visible'=>'0','enter_type'=>0),'id'=>$this->id));
		json_decode($this->CurlTo($json),true);
	}

	public function SendMessage($text)
	{
		$text = iconv('windows-1251','utf-8',$text);
		//$ttt = str_replace(' ',"©", $ttt);
		$json   = json_encode(array('jsonrpc' => '2.0', 'method' => 'send_public_mess', 'params' => array('conn_id' => $this->id_cont,'channel'=>$this->CommfortChanel,'message'=>$text,'mode'=>$this->TypeMessage),'id'=>$this->id));
		//settype($json, "string");
		$cyr_chars = array (
		'\u0430' => 'а', '\u0410' => 'А',
		'\u0431' => 'б', '\u0411' => 'Б',
		'\u0432' => 'в', '\u0412' => 'В',
		'\u0433' => 'г', '\u0413' => 'Г',
		'\u0434' => 'д', '\u0414' => 'Д',
		'\u0435' => 'е', '\u0415' => 'Е',
		'\u0451' => 'ё', '\u0401' => 'Ё',
		'\u0436' => 'ж', '\u0416' => 'Ж',
		'\u0437' => 'з', '\u0417' => 'З',
		'\u0438' => 'и', '\u0418' => 'И',
		'\u0439' => 'й', '\u0419' => 'Й',
		'\u043a' => 'к', '\u041a' => 'К',
		'\u043b' => 'л', '\u041b' => 'Л',
		'\u043c' => 'м', '\u041c' => 'М',
		'\u043d' => 'н', '\u041d' => 'Н',
		'\u043e' => 'о', '\u041e' => 'О',
		'\u043f' => 'п', '\u041f' => 'П',
		'\u0440' => 'р', '\u0420' => 'Р',
		'\u0441' => 'с', '\u0421' => 'С',
		'\u0442' => 'т', '\u0422' => 'Т',
		'\u0443' => 'у', '\u0423' => 'У',
		'\u0444' => 'ф', '\u0424' => 'Ф',
		'\u0445' => 'х', '\u0425' => 'Х',
		'\u0446' => 'ц', '\u0426' => 'Ц',
		'\u0447' => 'ч', '\u0427' => 'Ч',
		'\u0448' => 'ш', '\u0428' => 'Ш',
		'\u0449' => 'щ', '\u0429' => 'Щ',
		'\u044a' => 'ъ', '\u042a' => 'Ъ',
		'\u044b' => 'ы', '\u042b' => 'Ы',
		'\u044c' => 'ь', '\u042c' => 'Ь',
		'\u044d' => 'э', '\u042d' => 'Э',
		'\u044e' => 'ю', '\u042e' => 'Ю',
		'\u044f' => 'я', '\u042f' => 'Я',
		'\u00ab' => '«', '\u00bb' => '»',
		 ' ' => chr(0)
		);
		foreach ($cyr_chars as $cyr_char_key => $cyr_char) {
			$json = str_replace($cyr_char_key, $cyr_char, $json);
		}
		$json = str_replace('\\','',$json);
		echo $json;
		$this->CurlTo($json);
	}
	
	public function GetAction()
	{
		$json   = json_encode(array('jsonrpc' => '2.0', 'method' => 'get_actions', 'params' => array('conn_id' => $this->id_cont),'id'=>$this->id));
		return json_decode($this->CurlTo($json),true);
	}

}

?>